//    OpenVPN -- An application to securely tunnel IP networks
//               over a single port, with support for SSL/TLS-based
//               session authentication and key exchange,
//               packet encryption, packet authentication, and
//               packet compression.
//
//    Copyright (C) 2012-2022 OpenVPN Inc.
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License Version 3
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program in the COPYING file.
//    If not, see <http://www.gnu.org/licenses/>.

#ifndef OPENVPN_TUN_TUNMTU_H
#define OPENVPN_TUN_TUNMTU_H

#include <openvpn/common/options.hpp>

namespace openvpn {
enum
{
    TUN_MTU_DEFAULT = 1500,
};

inline unsigned int parse_tun_mtu(const OptionList &opt, unsigned int default_value)
{
    return opt.get_num<unsigned int>("tun-mtu", 1, default_value, 576, 65535);
}

inline unsigned int parse_tun_mtu_max(const OptionList &opt, unsigned int default_value)
{
    return opt.get_num<unsigned int>("tun-mtu-max", 1, default_value, 576, 65535);
}
} // namespace openvpn

#endif
